diff --git a/tensorflow/python/tpu/tpu_feed.py b/tensorflow/python/tpu/tpu_feed.py
index 2b01eeb3934..202bd2a02cd 100644
--- a/tensorflow/python/tpu/tpu_feed.py
+++ b/tensorflow/python/tpu/tpu_feed.py
@@ -23,7 +23,6 @@ from __future__ import print_function
 import itertools
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.compiler.xla.experimental.xla_sharding import xla_sharding
 from tensorflow.python.framework import dtypes
@@ -183,7 +182,7 @@ class InfeedQueue(object):
     # Make an empty sharding policy for each tuple element.
     self._sharding_policies = [
         tpu_sharding.ShardingPolicy()
-        for _ in xrange(number_of_tuple_elements)
+        for _ in range(number_of_tuple_elements)
     ]
     if tuple_types is not None:
       self.set_tuple_types(tuple_types)
@@ -416,14 +415,14 @@ class InfeedQueue(object):
     # Transpose the inputs to make a list of shard shapes for each tuple
     # element.
     sharded_shapes = [[t[i].shape for t in input_tensors]
-                      for i in xrange(self.number_of_tuple_elements)]
+                      for i in range(self.number_of_tuple_elements)]
     # For each tuple, get the unsharded shape using that tuple's policy.
     unsharded_shapes = [
         policy.get_unsharded_shape(s)
         for (policy, s) in zip(self._sharding_policies, sharded_shapes)
     ]
     self.set_tuple_shapes(unsharded_shapes)
-    for i in xrange(1, self.number_of_shards):
+    for i in range(1, self.number_of_shards):
       for (t1, t2) in zip(input_tensors[0], input_tensors[i]):
         if t1.dtype != t2.dtype:
           raise TypeError(
@@ -530,7 +529,7 @@ class InfeedQueue(object):
     shapes = [t.shape for t in inputs]
     if device is None:
       devices = [t.device for t in inputs]
-      for i in xrange(1, self.number_of_tuple_elements):
+      for i in range(1, self.number_of_tuple_elements):
         if devices[0] != devices[i]:
           raise ValueError(
               "input devices for shard %d are %s, but should all be the same" %
@@ -608,7 +607,7 @@ class InfeedQueue(object):
             index,
             tpu_ordinal=tpu_ordinal_function(index),
             device=placement_function(index) if placement_function else None)
-        for (shard, index) in zip(sharded_inputs, xrange(self.number_of_shards))
+        for (shard, index) in zip(sharded_inputs, range(self.number_of_shards))
     ]
 
   # TODO(misard) Generalize this to the case of systems that don't
@@ -714,10 +713,10 @@ class InfeedQueue(object):
               axis=policy.shard_dimension,
               name="%s/%d" % (split_name_prefix, index))
           for (inp, policy, index) in zip(inputs, self._sharding_policies,
-                                          xrange(self.number_of_tuple_elements))
+                                          range(self.number_of_tuple_elements))
       ]
     sharded_inputs = [[shard[i] for shard in transposed_sharded_inputs]
-                      for i in xrange(self.number_of_shards)]
+                      for i in range(self.number_of_shards)]
     name_prefix = "%s/enqueue" % self._name
     return [
         self._generate_enqueue_op(
@@ -726,7 +725,7 @@ class InfeedQueue(object):
             index,
             device=placement_function(index),
             tpu_ordinal=tpu_ordinal_function(index))
-        for (shard, index) in zip(sharded_inputs, xrange(self.number_of_shards))
+        for (shard, index) in zip(sharded_inputs, range(self.number_of_shards))
     ]
 
 
@@ -855,7 +854,7 @@ class _PartitionedInfeedQueue(InfeedQueue):
       # input_fn).
       replica_id = self._device_assignment.lookup_replicas(
           task_id=self._host_id, logical_core=0)[replica_index]
-      for logical_core in xrange(self._device_assignment.num_cores_per_replica):
+      for logical_core in range(self._device_assignment.num_cores_per_replica):
         # Places different partitions to different logic cores.
         # Since there can be multiple hosts per replica, we need to find
         # the actual host (device) of this logical core.
diff --git a/tensorflow/python/tpu/tpu_sharding.py b/tensorflow/python/tpu/tpu_sharding.py
index 2541cf241b8..7f5f370c046 100644
--- a/tensorflow/python/tpu/tpu_sharding.py
+++ b/tensorflow/python/tpu/tpu_sharding.py
@@ -19,7 +19,6 @@ from __future__ import absolute_import
 from __future__ import division
 from __future__ import print_function
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import tensor_shape
 
@@ -242,7 +241,7 @@ class ShardingPolicy(object):
           "shapes is %s but must be a list of length number_of_shards=%d" % (
               str(shapes), self.number_of_shards))
     unsharded_shapes = [self._unshard_shape(s) for s in shapes]
-    for i in xrange(self.number_of_shards - 1):
+    for i in range(self.number_of_shards - 1):
       if not unsharded_shapes[i].is_compatible_with(
           unsharded_shapes[self.number_of_shards - 1]):
         raise ValueError(
diff --git a/tensorflow/python/training/input.py b/tensorflow/python/training/input.py
index 41c8c715d77..5e52323f02a 100644
--- a/tensorflow/python/training/input.py
+++ b/tensorflow/python/training/input.py
@@ -24,7 +24,6 @@ from __future__ import absolute_import
 from __future__ import division
 from __future__ import print_function
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.eager import context
 from tensorflow.python.framework import constant_op
@@ -699,13 +698,13 @@ def _shapes(tensor_list_list, shapes, enqueue_many):
     len0 = len(tensor_list_list[0])
 
     for tl in tensor_list_list:
-      for i in xrange(len0):
+      for i in range(len0):
         if tl[i].shape.ndims is None:
           raise ValueError("Cannot infer Tensor's rank: %s" % tl[i])
 
     shapes = [_merge_shapes(
         [tl[i].shape.as_list() for tl in tensor_list_list], enqueue_many)
-              for i in xrange(len0)]
+              for i in range(len0)]
   return shapes
 
 
diff --git a/tensorflow/python/training/input_test.py b/tensorflow/python/training/input_test.py
index b82a2611d54..31b6496f08b 100644
--- a/tensorflow/python/training/input_test.py
+++ b/tensorflow/python/training/input_test.py
@@ -22,7 +22,6 @@ import itertools
 import os
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import constant_op
 from tensorflow.python.framework import dtypes
@@ -290,7 +289,7 @@ class RangeInputProducerTest(test_lib.TestCase):
 
       # No randomness, so just see repeated copies of the input.
       output = self.evaluate(dequeue_many)
-      self.assertAllEqual(list(xrange(range_size)) * num_epochs, output)
+      self.assertAllEqual(list(range(range_size)) * num_epochs, output)
 
       # Reached the limit.
       with self.assertRaises(errors_impl.OutOfRangeError):
diff --git a/tensorflow/python/training/momentum_test.py b/tensorflow/python/training/momentum_test.py
index ba155fa6c64..4658410264a 100644
--- a/tensorflow/python/training/momentum_test.py
+++ b/tensorflow/python/training/momentum_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.eager import context
 from tensorflow.python.framework import constant_op
@@ -453,7 +452,7 @@ class MomentumOptimizerTest(test.TestCase):
       mom_opt = momentum_lib.MomentumOptimizer(learning_rate=0.1, momentum=0.1)
       mom_update = mom_opt.apply_gradients(zip([grads0], [var0]))
       variables.global_variables_initializer().run()
-      for i in xrange(num_samples):
+      for i in range(num_samples):
         mom_update.run(feed_dict={grads0: db_grad[i]})
         self.assertAllClose(np.array(db_out[i]), self.evaluate(var0))
 
diff --git a/tensorflow/python/training/saver.py b/tensorflow/python/training/saver.py
index d65297fb30d..a84291aaab6 100644
--- a/tensorflow/python/training/saver.py
+++ b/tensorflow/python/training/saver.py
@@ -661,7 +661,7 @@ class Saver(object):
   saver = tf.compat.v1.train.Saver(...variables...)
   # Launch the graph and train, saving the model every 1,000 steps.
   sess = tf.compat.v1.Session()
-  for step in xrange(1000000):
+  for step in range(1000000):
       sess.run(..training_op..)
       if step % 1000 == 0:
           # Append the step number to the checkpoint name:
@@ -1368,7 +1368,7 @@ def import_meta_graph(meta_graph_or_file,
   # Remember the training_op we want to run by adding it to a collection.
   tf.compat.v1.add_to_collection('train_op', train_op)
   sess = tf.compat.v1.Session()
-  for step in xrange(1000000):
+  for step in range(1000000):
       sess.run(train_op)
       if step % 1000 == 0:
           # Saves checkpoint, which by default also exports a meta_graph
@@ -1387,7 +1387,7 @@ def import_meta_graph(meta_graph_or_file,
     # tf.get_collection() returns a list. In this example we only want
     # the first one.
     train_op = tf.get_collection('train_op')[0]
-    for step in xrange(1000000):
+    for step in range(1000000):
       sess.run(train_op)
   ```
 
diff --git a/tensorflow/python/training/supervisor.py b/tensorflow/python/training/supervisor.py
index 91960cb3f94..e1e94cb9fa5 100644
--- a/tensorflow/python/training/supervisor.py
+++ b/tensorflow/python/training/supervisor.py
@@ -179,7 +179,7 @@ class Supervisor(object):
   # As summary_op was None, managed_session() does not start the
   # summary thread.
   with sv.managed_session(FLAGS.master) as sess:
-    for step in xrange(1000000):
+    for step in range(1000000):
       if sv.should_stop():
         break
       if is_chief and step % 100 == 0:
@@ -951,7 +951,7 @@ class Supervisor(object):
     def train():
       sv = tf.compat.v1.train.Supervisor(...)
       with sv.managed_session(<master>) as sess:
-        for step in xrange(..):
+        for step in range(..):
           if sv.should_stop():
             break
           sess.run(<my training op>)
diff --git a/tensorflow/python/training/supervisor_test.py b/tensorflow/python/training/supervisor_test.py
index 180ddb52876..ef31a0748fc 100644
--- a/tensorflow/python/training/supervisor_test.py
+++ b/tensorflow/python/training/supervisor_test.py
@@ -24,7 +24,6 @@ import shutil
 import time
 import uuid
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.core.framework import graph_pb2
 from tensorflow.core.protobuf import config_pb2
@@ -100,7 +99,7 @@ class SupervisorTest(test.TestCase):
       my_op = constant_op.constant(1.0)
       sv = supervisor.Supervisor(logdir=logdir)
       sess = sv.prepare_or_wait_for_session("")
-      for _ in xrange(10):
+      for _ in range(10):
         self.evaluate(my_op)
       sess.close()
       sv.stop()
@@ -111,7 +110,7 @@ class SupervisorTest(test.TestCase):
       my_op = constant_op.constant(1.0)
       sv = supervisor.Supervisor(logdir=logdir)
       with sv.managed_session("") as sess:
-        for _ in xrange(10):
+        for _ in range(10):
           self.evaluate(my_op)
       # Supervisor has been stopped.
       self.assertTrue(sv.should_stop())
@@ -124,7 +123,7 @@ class SupervisorTest(test.TestCase):
       last_step = None
       with self.assertRaisesRegexp(RuntimeError, "failing here"):
         with sv.managed_session("") as sess:
-          for step in xrange(10):
+          for step in range(10):
             last_step = step
             if step == 1:
               raise RuntimeError("failing here")
@@ -141,7 +140,7 @@ class SupervisorTest(test.TestCase):
       sv = supervisor.Supervisor(logdir=logdir)
       last_step = None
       with sv.managed_session("") as sess:
-        for step in xrange(10):
+        for step in range(10):
           last_step = step
           if step == 3:
             raise errors_impl.OutOfRangeError(my_op.op.node_def, my_op.op,
@@ -335,7 +334,7 @@ class SupervisorTest(test.TestCase):
       sv = supervisor.Supervisor(logdir=logdir)
       sess = sv.prepare_or_wait_for_session(
           "", config=config_pb2.ConfigProto(device_count={"CPU": 2}))
-      for _ in xrange(10):
+      for _ in range(10):
         self.evaluate(my_op)
       sess.close()
       sv.stop()
diff --git a/tensorflow/python/training/tracking/benchmarks_test.py b/tensorflow/python/training/tracking/benchmarks_test.py
index 7514d9f54cf..632c823774a 100644
--- a/tensorflow/python/training/tracking/benchmarks_test.py
+++ b/tensorflow/python/training/tracking/benchmarks_test.py
@@ -77,7 +77,7 @@ class SavingBenchmarks(test.Benchmark):
   def _run(self, func, num_iters, execution_mode=None):
     func()
     start = time.time()
-    for _ in xrange(num_iters):
+    for _ in range(num_iters):
       func()
     end = time.time()
     mean_us = (end - start) * 1e6 / num_iters
diff --git a/tensorflow/python/util/nest_test.py b/tensorflow/python/util/nest_test.py
index 6ec4a5d61f9..b1a7237c139 100644
--- a/tensorflow/python/util/nest_test.py
+++ b/tensorflow/python/util/nest_test.py
@@ -23,7 +23,6 @@ import time
 
 from absl.testing import parameterized
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import constant_op
 from tensorflow.python.framework import dtypes
@@ -1215,11 +1214,11 @@ class NestBenchmark(test.Benchmark):
   def run_and_report(self, s1, s2, name):
     burn_iter, test_iter = 100, 30000
 
-    for _ in xrange(burn_iter):
+    for _ in range(burn_iter):
       nest.assert_same_structure(s1, s2)
 
     t0 = time.time()
-    for _ in xrange(test_iter):
+    for _ in range(test_iter):
       nest.assert_same_structure(s1, s2)
     t1 = time.time()
 
diff --git a/tensorflow/python/util/tf_inspect.py b/tensorflow/python/util/tf_inspect.py
index ee2df3cb21b..793a12154e0 100644
--- a/tensorflow/python/util/tf_inspect.py
+++ b/tensorflow/python/util/tf_inspect.py
@@ -25,12 +25,15 @@ import six
 
 from tensorflow.python.util import tf_decorator
 
-ArgSpec = _inspect.ArgSpec
 
 
 if hasattr(_inspect, 'FullArgSpec'):
   FullArgSpec = _inspect.FullArgSpec  # pylint: disable=invalid-name
+  ArgSpec = collections.namedtuple('ArgSpec', [
+      'args', 'varargs', 'keywords', 'defaults',
+  ])
 else:
+  ArgSpec = _inspect.ArgSpec
   FullArgSpec = collections.namedtuple('FullArgSpec', [
       'args', 'varargs', 'varkw', 'defaults', 'kwonlyargs', 'kwonlydefaults',
       'annotations'
diff --git a/tensorflow/python/util/tf_stack.cc b/tensorflow/python/util/tf_stack.cc
index d6551ccb98c..8bdbde1c796 100644
--- a/tensorflow/python/util/tf_stack.cc
+++ b/tensorflow/python/util/tf_stack.cc
@@ -53,13 +53,22 @@ std::vector<StackFrame> ExtractStack(ssize_t limit, const py::list& mappers,
 
   const auto* tstate = PyThreadState_GET();
   // Drop extract_stack() wrapper-function frame from the result.
+#if PY_MINOR_VERSION >= 9
+  const PyFrameObject* f = PyFrame_GetBack(PyThreadState_GetFrame(const_cast<PyThreadState*>(tstate)));
+#else
   const PyFrameObject* f = tstate->frame->f_back;  // TODO(slebedev): INCREF?
+#endif
 
   std::vector<StackFrame> ret;
   // 16 is somewhat arbitrary, but TensorFlow stack traces tend to be deep.
   ret.reserve(limit < 0 ? 16 : static_cast<size_t>(limit));
+#if PY_MINOR_VERSION >= 9
+  for (; f != nullptr && (limit < 0 || ret.size() < limit); f = PyFrame_GetBack(const_cast<PyFrameObject*>(f))) {
+    PyCodeObject* co = PyFrame_GetCode(const_cast<PyFrameObject*>(f));
+#else
   for (; f != nullptr && (limit < 0 || ret.size() < limit); f = f->f_back) {
     PyCodeObject* co = f->f_code;
+#endif
     int lineno = PyFrame_GetLineNumber(const_cast<PyFrameObject*>(f));
     auto filename = py::reinterpret_borrow<py::str>(co->co_filename);
     auto name = py::reinterpret_borrow<py::str>(co->co_name);
@@ -81,7 +90,11 @@ std::vector<StackFrame> ExtractStack(ssize_t limit, const py::list& mappers,
         PySet_Contains(filtered_filenames.ptr(), filename.ptr()))
       continue;
 
+#if PY_MINOR_VERSION >= 11
+    const auto& globals = py::reinterpret_borrow<py::object>(PyFrame_GetGlobals(const_cast<PyFrameObject*>(f)));
+#else
     const auto& globals = py::reinterpret_borrow<py::object>(f->f_globals);
+#endif
     const int func_start_lineno = co->co_firstlineno;
     ret.push_back({std::move(filename), lineno, std::move(name), globals,
                    func_start_lineno});
diff --git a/tensorflow/stream_executor/cuda/BUILD b/tensorflow/stream_executor/cuda/BUILD
index 27b1364c6cb..700d9734ec0 100644
--- a/tensorflow/stream_executor/cuda/BUILD
+++ b/tensorflow/stream_executor/cuda/BUILD
@@ -88,7 +88,7 @@ cc_library(
 cc_library(
     name = "cuda_stub",
     srcs = if_cuda_is_configured(["cuda_stub.cc"]),
-    textual_hdrs = ["cuda_10_0.inc"],
+    textual_hdrs = ["cuda_12_0.inc"],
     deps = if_cuda_is_configured([
         "@local_config_cuda//cuda:cuda_headers",
         "//tensorflow/stream_executor/lib",
diff --git a/tensorflow/stream_executor/cuda/cublas_stub.cc b/tensorflow/stream_executor/cuda/cublas_stub.cc
index b8e203fe235..f9cfcc9d4b3 100644
--- a/tensorflow/stream_executor/cuda/cublas_stub.cc
+++ b/tensorflow/stream_executor/cuda/cublas_stub.cc
@@ -61,5 +61,5 @@ typedef enum {} cublasMath_t;
 #if CUDA_VERSION < 9020
 #include "tensorflow/stream_executor/cuda/cublas_9_0.inc"
 #else
-#include "tensorflow/stream_executor/cuda/cublas_10_0.inc"
+#include "tensorflow/stream_executor/cuda/cublas_11_0.inc"
 #endif
diff --git a/tensorflow/stream_executor/cuda/cuda_dnn.cc b/tensorflow/stream_executor/cuda/cuda_dnn.cc
index 076831671ea..760aa4c71f4 100755
--- a/tensorflow/stream_executor/cuda/cuda_dnn.cc
+++ b/tensorflow/stream_executor/cuda/cuda_dnn.cc
@@ -181,7 +181,7 @@ class CudnnAccess {
   // therefore a bad idea (performance wise) to call any cuDNN APIs that
   // enqueue work in the stream.
   CudnnHandle GetHandle(GpuExecutor* executor, Stream* stream) {
-    auto lock = absl::make_unique<absl::MutexLock>(&mutex_);
+    auto lock = std::make_unique<absl::MutexLock>(&mutex_);
     mutex_.AssertHeld();
     gpu::ScopedActivateExecutorContext context(executor);
     CUstream cu_stream = stream ? AsGpuStreamValue(stream) : cudaStreamLegacy;
@@ -1208,7 +1208,7 @@ port::Status CheckAndFetchProjectionWeights(
   cudnnRNNMode_t mode;
   cudnnRNNAlgo_t algo;
   cudnnDataType_t data_type;
-  RETURN_IF_CUDNN_ERROR(cudnnGetRNNDescriptor(
+  RETURN_IF_CUDNN_ERROR(cudnnGetRNNDescriptor_v6(
       /*handle=*/cudnn.handle(), /*rnnDesc=*/rnn_desc,
       /*hiddenSize=*/&hidden_size_v,
       /*numLayers=*/&num_layers_v,
@@ -2314,7 +2314,7 @@ namespace {
 
 // TODO(csigg): Merge a lot of duplicate code below for forward, backward data,
 // and backward filter.
-
+/*
 port::StatusOr<cudnnConvolutionFwdAlgo_t> GetCudnnConvolutionForwardAlgo(
     const CudnnHandle& cudnn, const CudnnTensorDescriptor& input_nd,
     const CudnnFilterDescriptor& filter, const CudnnConvolutionDescriptor& conv,
@@ -2367,7 +2367,7 @@ GetCudnnConvolutionBackwardFilterAlgo(const CudnnHandle& cudnn,
       filter.handle(), preference, memory_limit_bytes, &algo_to_use));
   return algo_to_use;
 }
-
+*/
 port::StatusOr<DeviceMemory<uint8>> AllocateCudnnConvolutionForwardWorkspace(
     Stream* stream, const CudnnHandle& cudnn,
     const CudnnTensorDescriptor& input_nd, const CudnnFilterDescriptor& filter,
@@ -2515,6 +2515,7 @@ port::StatusOr<dnn::AlgorithmDesc> GetCudnnConvolutionForwardAlgorithm(
   if (!algo_desc.has_value()) {
     // Pick fastest algorithm within memory limit according to cuDNN's
     // heuristics.
+    /*
     bool specify_workspace_limit = scratch_allocator != nullptr;
     auto memory_limit_bytes =
         specify_workspace_limit
@@ -2524,12 +2525,13 @@ port::StatusOr<dnn::AlgorithmDesc> GetCudnnConvolutionForwardAlgorithm(
                         GetCudnnConvolutionForwardAlgo(
                             cudnn, input_nd, filter, conv, output_nd,
                             specify_workspace_limit, memory_limit_bytes));
+    */
+    cudnnConvolutionFwdAlgo_t algo = CUDNN_CONVOLUTION_FWD_ALGO_IMPLICIT_GEMM;
     int cc_major, cc_minor;
     std::tie(cc_major, cc_minor) = GetCcMajorMinor(stream);
     algo_desc = dnn::AlgorithmDesc(
         algo, /*use_tensor_ops=*/TensorOpMathAvailable(cc_major));
   }
-
   const auto scratch_or = AllocateCudnnConvolutionForwardWorkspace(
       stream, cudnn, input_nd, filter, conv, output_nd, *algo_desc,
       scratch_allocator);
@@ -2568,6 +2570,7 @@ port::StatusOr<dnn::AlgorithmDesc> GetCudnnConvolutionBackwardDataAlgorithm(
   if (!algo_desc.has_value()) {
     // Pick fastest algorithm within memory limit according to cuDNN's
     // heuristics.
+    /*
     bool specify_workspace_limit = scratch_allocator != nullptr;
     auto memory_limit_bytes =
         specify_workspace_limit
@@ -2577,12 +2580,13 @@ port::StatusOr<dnn::AlgorithmDesc> GetCudnnConvolutionBackwardDataAlgorithm(
                         GetCudnnConvolutionBackwardDataAlgo(
                             cudnn, input_nd, filter, conv, output_nd,
                             specify_workspace_limit, memory_limit_bytes));
+    */
+    cudnnConvolutionBwdDataAlgo_t algo = CUDNN_CONVOLUTION_BWD_DATA_ALGO_0;
     int cc_major, cc_minor;
     std::tie(cc_major, cc_minor) = GetCcMajorMinor(stream);
     algo_desc = dnn::AlgorithmDesc(
         algo, /*use_tensor_ops=*/TensorOpMathAvailable(cc_major));
   }
-
   const auto scratch_or = AllocateCudnnConvolutionBackwardDataWorkspace(
       stream, cudnn, input_nd, filter, conv, output_nd, *algo_desc,
       scratch_allocator);
@@ -2620,6 +2624,7 @@ port::StatusOr<dnn::AlgorithmDesc> GetCudnnConvolutionBackwardFilterAlgorithm(
   if (!algo_desc.has_value()) {
     // Pick fastest algorithm within memory limit according to cuDNN's
     // heuristics.
+    /*
     bool specify_workspace_limit = scratch_allocator != nullptr;
     auto memory_limit_bytes =
         specify_workspace_limit
@@ -2629,12 +2634,13 @@ port::StatusOr<dnn::AlgorithmDesc> GetCudnnConvolutionBackwardFilterAlgorithm(
                         GetCudnnConvolutionBackwardFilterAlgo(
                             cudnn, input_nd, filter, conv, output_nd,
                             specify_workspace_limit, memory_limit_bytes));
+    */
+    cudnnConvolutionBwdFilterAlgo_t algo = CUDNN_CONVOLUTION_BWD_FILTER_ALGO_0;
     int cc_major, cc_minor;
     std::tie(cc_major, cc_minor) = GetCcMajorMinor(stream);
     algo_desc = dnn::AlgorithmDesc(
         algo, /*use_tensor_ops=*/TensorOpMathAvailable(cc_major));
   }
-
   auto scratch_or = AllocateCudnnConvolutionBackwardFilterWorkspace(
       stream, cudnn, input_nd, filter, conv, output_nd, *algo_desc,
       scratch_allocator);
diff --git a/tensorflow/stream_executor/cuda/cuda_driver.cc b/tensorflow/stream_executor/cuda/cuda_driver.cc
index f7a69fc086a..92a4e911da0 100644
--- a/tensorflow/stream_executor/cuda/cuda_driver.cc
+++ b/tensorflow/stream_executor/cuda/cuda_driver.cc
@@ -178,7 +178,7 @@ void CheckPointerIsValid(const PtrT ptr, absl::string_view name) {
   // If we failed, reset cuda error status to avoid poisoning cuda streams.
   if (err != cudaSuccess) cudaGetLastError();
   bool points_to_host_memory = (err == cudaErrorInvalidValue ||
-                                attributes.memoryType != cudaMemoryTypeDevice);
+                                attributes.type != cudaMemoryTypeDevice);
   CHECK_EQ(is_host_ptr, points_to_host_memory) << absl::StreamFormat(
       "%s pointer is not actually on %s: %p", name, is_host_ptr ? "CPU" : "GPU",
       reinterpret_cast<const void*>(ptr));
diff --git a/tensorflow/stream_executor/cuda/cuda_stub.cc b/tensorflow/stream_executor/cuda/cuda_stub.cc
index 3248c9ddefd..db9948d5a07 100644
--- a/tensorflow/stream_executor/cuda/cuda_stub.cc
+++ b/tensorflow/stream_executor/cuda/cuda_stub.cc
@@ -61,6 +61,7 @@ typedef struct CUDA_LAUNCH_PARAMS_st CUDA_LAUNCH_PARAMS;
 #define __CUDA_DEPRECATED
 #endif
 
+#if CUDA_VERSION < 12000
 #if CUDA_VERSION < 10000
 // Define fake enums introduced in CUDA 10.0.
 typedef enum CUgraphNodeType_enum {} CUgraphNodeType;
@@ -93,7 +94,9 @@ typedef struct CUDA_EXTERNAL_SEMAPHORE_WAIT_PARAMS_st
     CUDA_EXTERNAL_SEMAPHORE_WAIT_PARAMS;
 typedef void(CUDA_CB* CUhostFn)(void* userData);
 
+#endif
+
 // For now only one stub implementation is needed. If a function that is not
 // available in the given CUDA release, the corresponding wrapper returns
 // CUDA_ERROR_SHARED_OBJECT_INIT_FAILED.
-#include "tensorflow/stream_executor/cuda/cuda_10_0.inc"
+#include "tensorflow/stream_executor/cuda/cuda_12_0.inc"
diff --git a/tensorflow/stream_executor/cuda/cudart_stub.cc b/tensorflow/stream_executor/cuda/cudart_stub.cc
index 0c6b274f88b..d19eeea7dc9 100644
--- a/tensorflow/stream_executor/cuda/cudart_stub.cc
+++ b/tensorflow/stream_executor/cuda/cudart_stub.cc
@@ -56,7 +56,7 @@ cudaError_t GetSymbolNotFoundError() {
 #elif CUDART_VERSION < 10010
 #include "tensorflow/stream_executor/cuda/cuda_runtime_10_0.inc"
 #else
-#include "tensorflow/stream_executor/cuda/cuda_runtime_10_1.inc"
+#include "tensorflow/stream_executor/cuda/cuda_runtime_12_0.inc"
 #endif
 #undef __dv
 #undef __CUDA_DEPRECATED
diff --git a/tensorflow/stream_executor/cuda/cudnn_stub.cc b/tensorflow/stream_executor/cuda/cudnn_stub.cc
index 5a05437480e..85141973ed4 100644
--- a/tensorflow/stream_executor/cuda/cudnn_stub.cc
+++ b/tensorflow/stream_executor/cuda/cudnn_stub.cc
@@ -60,5 +60,5 @@ cudnnStatus_t GetSymbolNotFoundError() { return CUDNN_STATUS_INTERNAL_ERROR; }
 #elif CUDNN_MINOR < 6
 #include "tensorflow/stream_executor/cuda/cudnn_7_4.inc"
 #else
-#include "tensorflow/stream_executor/cuda/cudnn_7_6.inc"
+#include "tensorflow/stream_executor/cuda/cudnn_8_0.inc"
 #endif
diff --git a/tensorflow/stream_executor/cuda/cusparse_stub.cc b/tensorflow/stream_executor/cuda/cusparse_stub.cc
index 439de5eb83a..751ecb838eb 100644
--- a/tensorflow/stream_executor/cuda/cusparse_stub.cc
+++ b/tensorflow/stream_executor/cuda/cusparse_stub.cc
@@ -50,8 +50,4 @@ cusparseStatus_t GetSymbolNotFoundError() {
 }
 }  // namespace
 
-#if CUDA_VERSION < 9020
-#include "tensorflow/stream_executor/cuda/cusparse_9_0.inc"
-#else
-#include "tensorflow/stream_executor/cuda/cusparse_10_0.inc"
-#endif
+#include "tensorflow/stream_executor/cuda/cusparse_12_0.inc"
diff --git a/tensorflow/stream_executor/platform/default/dso_loader.cc b/tensorflow/stream_executor/platform/default/dso_loader.cc
index 9ae8b41ccf4..8f4d9904322 100644
--- a/tensorflow/stream_executor/platform/default/dso_loader.cc
+++ b/tensorflow/stream_executor/platform/default/dso_loader.cc
@@ -73,7 +73,7 @@ port::StatusOr<void*> GetCudaDriverDsoHandle() {
 }
 
 port::StatusOr<void*> GetCudaRuntimeDsoHandle() {
-  return GetDsoHandle("cudart", GetCudaVersion());
+  return GetDsoHandle("cudart", GetCudaLibVersion());
 }
 
 port::StatusOr<void*> GetCublasDsoHandle() {
@@ -81,11 +81,11 @@ port::StatusOr<void*> GetCublasDsoHandle() {
 }
 
 port::StatusOr<void*> GetCufftDsoHandle() {
-  return GetDsoHandle("cufft", GetCudaLibVersion());
+  return GetDsoHandle("cufft", "11");
 }
 
 port::StatusOr<void*> GetCusolverDsoHandle() {
-  return GetDsoHandle("cusolver", GetCudaLibVersion());
+  return GetDsoHandle("cusolver", "11");
 }
 
 port::StatusOr<void*> GetCusparseDsoHandle() {
@@ -93,7 +93,7 @@ port::StatusOr<void*> GetCusparseDsoHandle() {
 }
 
 port::StatusOr<void*> GetCurandDsoHandle() {
-  return GetDsoHandle("curand", GetCudaLibVersion());
+  return GetDsoHandle("curand", "10");
 }
 
 port::StatusOr<void*> GetCuptiDsoHandle() {
diff --git a/tensorflow/stream_executor/stream_executor_pimpl.h b/tensorflow/stream_executor/stream_executor_pimpl.h
index efa4034c88a..aae01ce94a7 100644
--- a/tensorflow/stream_executor/stream_executor_pimpl.h
+++ b/tensorflow/stream_executor/stream_executor_pimpl.h
@@ -772,7 +772,7 @@ inline port::StatusOr<std::unique_ptr<TypedKernel<Args...>>>
 StreamExecutor::CreateTypedKernel(absl::string_view kernel_name,
                                   absl::string_view ptx,
                                   absl::Span<const uint8> cubin_data) {
-  auto kernel_base = absl::make_unique<TypedKernel<Args...>>(this);
+  auto kernel_base = std::make_unique<TypedKernel<Args...>>(this);
   MultiKernelLoaderSpec loader_spec(kernel_base->kNumberOfParameters);
   loader_spec.AddCudaPtxInMemory(ptx, kernel_name);
 
diff --git a/tensorflow/tools/lib_package/BUILD b/tensorflow/tools/lib_package/BUILD
index f7b9255092f..c6cbb2cdb62 100644
--- a/tensorflow/tools/lib_package/BUILD
+++ b/tensorflow/tools/lib_package/BUILD
@@ -187,7 +187,6 @@ genrule(
         ],
         "//conditions:default": [],
     }) + if_cuda([
-        "@cub_archive//:LICENSE.TXT",
         "@local_config_nccl//:LICENSE",
     ]) + if_mkl([
         "//third_party/mkl:LICENSE",
@@ -261,7 +260,6 @@ genrule(
         ],
         "//conditions:default": [],
     }) + if_cuda([
-        "@cub_archive//:LICENSE.TXT",
         "@local_config_nccl//:LICENSE",
     ]) + if_mkl([
         "//third_party/mkl:LICENSE",
diff --git a/tensorflow/tools/pip_package/BUILD b/tensorflow/tools/pip_package/BUILD
index 1573618f7c3..ccc5bf97ada 100644
--- a/tensorflow/tools/pip_package/BUILD
+++ b/tensorflow/tools/pip_package/BUILD
@@ -156,7 +156,7 @@ filegroup(
         "@nsync//:LICENSE",
         "@opt_einsum_archive//:LICENSE",
         "@pasta//:LICENSE",
-        "@pcre//:LICENCE",
+        "@pcre2//:LICENCE.md",
         "@png_archive//:LICENSE",
         "@com_google_protobuf//:LICENSE",
         "@six_archive//:LICENSE",
@@ -199,7 +199,6 @@ filegroup(
         ],
         "//conditions:default": [],
     }) + if_cuda([
-        "@cub_archive//:LICENSE.TXT",
         "@local_config_nccl//:LICENSE",
     ]) + if_mkl([
         "//third_party/mkl:LICENSE",
diff --git a/tensorflow/tools/pip_package/setup.py b/tensorflow/tools/pip_package/setup.py
index f47878fdd7f..546e381c0df 100644
--- a/tensorflow/tools/pip_package/setup.py
+++ b/tensorflow/tools/pip_package/setup.py
@@ -62,11 +62,11 @@ REQUIRED_PACKAGES = [
     'keras_preprocessing >= 1.0.5',
     # mock comes with unittest.mock for python3, need to install for python2
     'mock >= 2.0.0;python_version<"3"',
-    'numpy >= 1.16.0, < 1.19.0',
+    'numpy >= 1.16.0, < 2',
     'opt_einsum >= 2.3.2',
     'six >= 1.10.0',
-    'protobuf >= 3.6.1',
-    'tensorboard >= 1.15.0, < 1.16.0',
+    'protobuf >= 3.6.1, < 4',
+    'tensorboard >= 1.15.0',
     'tensorflow-estimator == 1.15.1',
     'termcolor >= 1.1.0',
     # python3 requires wheel 0.26
@@ -74,7 +74,7 @@ REQUIRED_PACKAGES = [
     'wheel;python_version<"3"',
     'wrapt >= 1.11.1',
     # Pin h5py to at most 2.10.0 as newer versions break old keras tests
-    'h5py <= 2.10.0',
+    'h5py',
 ]
 
 if sys.byteorder == 'little':
